<template>
  <div class="p-4">
    <BasicTable :clickToRowSelect="false" @register="registerTable" @fetch-success="onFetchSuccess">
      <template #toolbar>
        <Authority value="api:yt:organization:post">
          <a-button type="primary" @click="handleCreate">
            {{ getI18n }}
          </a-button>
        </Authority>
        <Authority value="api:yt:organization:delete">
          <Popconfirm
            title="您确定要批量删除数据"
            ok-text="确定"
            cancel-text="取消"
            @confirm="handleDeleteOrBatchDelete(null)"
          >
            <a-button color="error" :disabled="hasBatchDelete"> 批量删除 </a-button>
          </Popconfirm>
        </Authority>
      </template>
      <template #action="{ record }">
        <TableAction
          :actions="[
            {
              label: '编辑',
              auth: 'api:yt:organization:update',
              icon: 'clarity:note-edit-line',
              onClick: handleEdit.bind(null, record),
            },
            {
              label: '删除',
              auth: 'api:yt:organization:delete',
              icon: 'ant-design:delete-outlined',
              color: 'error',
              popConfirm: {
                title: getDeleteTitle(), //是否确认删除//getDeleteTitle()
                confirm: handleDeleteOrBatchDelete.bind(null, record),
              },
            },
          ]"
        />
      </template>
    </BasicTable>
    <DeptDrawer @register="registerModal" @success="handleSuccess" />
  </div>
</template>
<script lang="ts">
  import { computed, defineComponent, nextTick } from 'vue';
  import { BasicTable, useTable, TableAction } from '/@/components/Table';
  // 加载自定义侧边弹出框 组件
  import { useDrawer } from '/@/components/Drawer';
  import DeptDrawer from './OrganizationDrawer.vue';
  import { columns } from './organization.data';
  import { useI18n } from '/@/hooks/web/useI18n';
  import { delOrganization, getOrganizationList } from '/@/api/system/system';
  import { useBatchDelete } from '/@/hooks/web/useBatchDelete';
  import { Authority } from '/@/components/Authority';
  import { Popconfirm } from 'ant-design-vue';

  export default defineComponent({
    name: 'DeptManagement',
    components: { BasicTable, DeptDrawer, TableAction, Authority, Popconfirm },
    setup() {
      const [registerModal, { openDrawer }] = useDrawer();
      const { t } = useI18n(); //加载国际化
      const getI18n = computed(() => t('routes.common.organization.toolCreateOrganization'));

      const [registerTable, { reload, expandAll, setProps }] = useTable({
        title: t('routes.common.organization.toolOrganizationList'),
        api: getOrganizationList,
        columns,
        isTreeTable: true,
        pagination: false,
        striped: false,
        useSearchForm: false,
        showTableSetting: true,
        bordered: true,
        showIndexColumn: false,
        canResize: false,
        actionColumn: {
          width: 200,
          title: t('routes.common.common.operation'), //操作
          dataIndex: 'action',
          slots: { customRender: 'action' },
          fixed: 'right',
        },
      });

      const { hasBatchDelete, handleDeleteOrBatchDelete, selectionOptions } = useBatchDelete(
        delOrganization,
        handleSuccess,
        setProps
      );
      nextTick(() => {
        setProps(selectionOptions);
      });
      /**
       * 获得删除提示框的文字
       */
      function getDeleteTitle(): string {
        let labelText = t('routes.common.system.pageSystemTitleWhetherDelete');
        return labelText;
      }

      function handleCreate() {
        openDrawer(true, {
          isUpdate: false,
        });
      }

      function handleEdit(record: Recordable) {
        openDrawer(true, {
          record,
          isUpdate: true,
        });
      }

      function handleSuccess() {
        reload();
      }

      function onFetchSuccess() {
        // 演示默认展开所有表项
        nextTick(expandAll);
      }

      return {
        getI18n,
        registerTable,
        registerModal,
        getDeleteTitle,
        handleCreate,
        handleEdit,
        handleSuccess,
        onFetchSuccess,
        hasBatchDelete,
        handleDeleteOrBatchDelete,
      };
    },
  });
</script>
